
/* gg630504.hg9ieg 2011-08-28 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "ggstd.h"

#define iFieldLim	100
#define iLinLim		1024


typedef	struct	{
CH		chType;
SZ		szValue;
}		FIELD;


FIELD		FieldMp[iFieldLim] = { {0} };
I		iFieldMax = 0;
I		iRecCnt = 0;


//---------------------------------------------------------------------
// kiírja az i_. mezőt.
R		RWriteI( I );
R		RWriteI( i_ )
I		i_;
{
PCH		pch;

if( i_ >= iFieldMax )
	return( rNotFound );

pch = FieldMp[i_].szValue;

if( *pch != chEos )
	{
	if( FieldMp[i_].chType == 'd' )
		pch[10] = chEos; // dátum, csak az eleje kell

	if( FieldMp[i_].chType != 'n' )
		fputc( '\"', stdout );

	while( *pch != chEos )
		{
		if( *pch == '\"' )
			fputc( '\"', stdout );
		fputc( *pch++, stdout );
		}

	if( FieldMp[i_].chType != 'n' )
		fputc( '\"', stdout );
	}
return( rSucced );
}

//---------------------------------------------------------------------
// kiírja az aktuális rekordot ( sort )
R		RWriteV( void );
R		RWriteV()
{
I		i;
R		r = rSucced;

for( i = 0; i < iFieldMax; i++ )
	{
	RWriteI( i );
	if( i < iFieldMax-1 )
		fputc( ',', stdout );
	}
fputc( '\n', stdout );

iRecCnt++;

return( r );
}


//---------------------------------------------------------------------
// átmásolja az állományt
R		RCopyV( void );
R		RCopyV()
{
I		i;
R		r = rSucced;
SZ		szAct;
SZ		szLeft;
SZ		szLin;
SZ		szRight;

if( ( szLin = malloc( iLinLim+2 ) )==NULL ) { r = rNotMemo; goto ret; }

// első rekord kihagyása
while( (szLin = fgets( szLin, iLinLim, stdin ) )!=NULL && strncmp( szLin, "</Row>", 6 )!=0 )
	;

while( (szLin = fgets( szLin, iLinLim, stdin ) )!=NULL )
	{
	szLin[iLinLim-1] = chEos;

	if( strncmp( szLin, "<Row>", 5 )==0 )
		{
		for( i = 0; i < iFieldLim; i++ )
			ifree( FieldMp[i].szValue );
		iFieldMax = 0;
		}

	if( ( szRight = strstr(szLin, "</Data>"))!=NULL && iFieldMax < iFieldLim )
		{
		if( ( szLeft = strstr(szLin, "<Data ss:Type=\"String\">" ) )!=NULL )
			{
			szLeft += 23;
			FieldMp[iFieldMax].chType = 's';
			if( ( szAct = FieldMp[iFieldMax].szValue = malloc( (szRight-szLeft)+2 ) )==NULL ) { r = rNotMemo; goto ret; }
			while( szLeft != szRight )
				*szAct++ = *szLeft++;
			*szAct = chEos;
			iFieldMax++;
			}

		if( ( szLeft = strstr(szLin, "<Data ss:Type=\"Number\">" ) )!=NULL )
			{
			szLeft += 23;
			FieldMp[iFieldMax].chType = 'n';
			if( ( szAct = FieldMp[iFieldMax].szValue = malloc( (szRight-szLeft)+2 ) )==NULL ) { r = rNotMemo; goto ret; }
			while( szLeft != szRight )
				*szAct++ = *szLeft++;
			*szAct = chEos;
			iFieldMax++;
			}

		if( ( szLeft = strstr(szLin, "<Data ss:Type=\"DateTime\">" ) )!=NULL )
			{
			szLeft += 25;
			FieldMp[iFieldMax].chType = 'd';
			if( ( szAct = FieldMp[iFieldMax].szValue = malloc( (szRight-szLeft)+2 ) )==NULL ) { r = rNotMemo; goto ret; }
			while( szLeft != szRight )
				*szAct++ = *szLeft++;
			*szAct = chEos;
			iFieldMax++;
			}
		}

	if( strncmp( szLin, "</Row>", 6 )==0 )
		{
		RWriteV();
		for( i = 0; i < iFieldLim; i++ )
			ifree( FieldMp[i].szValue );
		iFieldMax = 0;
		}
	}

ret:
ifree( szLin );
return( r );
}

//---------------------------------------------------------------------
// stdout: csv
// stdin: NMHH/xml
R		main( cv_, pszv_, psze_ )
C		cv_;
PSZ		pszv_;
PSZ		psze_;
{
R		r = 0;

fprintf( stderr, "csv_xml: NMHH hívójelkönyv konvertáló GG630504 HG9IEG " __DATE__ "\n" );
RCopyV();
fprintf( stderr, "%d rekord.\n", iRecCnt );
return( r );
}

