//	gg630504 hg9ieg
//	2009-10-10
//	linux.ubuntu.gcc 32 bit

#ifndef _ggstd_
#define _ggstd_

#include <stdlib.h>

#define szPrgr		"gg630504.hg9ieg"

enum { fFalse, fTrue, fLim };

enum {
lanHun,	// magyar nyelv
lanEng,	// angol
lanLim
};


#define cLinLim		65536	// szövegsor hossza
#define chEol		'\n'
#define chEos		'\0'
#define chSwitch	'-'
#define cuEol		'\n'
#define cuEos		0
#define cZA		('Z'-'A'+1)
#define mcEof		EOF
#define mcEol		'\n'
#define mcEos		0
#define szSwitch	"-"

typedef signed char		W1;	// 1 byte
typedef unsigned char		U1;

typedef signed short int	W2;	// 2 byte
typedef unsigned short int	U2;

typedef signed int		W4;	// 4 byte
typedef unsigned int		U4;

typedef signed long long int	W8;	// 8 byte
typedef unsigned long long int	U8;

typedef char		CH;	// char
typedef double		D;
typedef int		CCH;	// count of char
typedef int		C;	// count
typedef int		CU;	// unicode char
typedef int		ICH;	// index of char
typedef int		I;	// index
typedef int		LAN;	// language
typedef int		MC;	// metachar
typedef int		R;	// return code
typedef int		SC;	// sort code
typedef int		W;	// word
typedef long long int	LI;	// long index
typedef long long int	LW;	// long word
typedef short int	SW;	// short word
typedef signed char	SCH;	// signed char
typedef size_t		S;	// size
typedef unsigned char	F;	// flag, fFalse, fTrue
typedef unsigned char	UCH;	// unsigned char
typedef unsigned int	U;	// unsigned int
typedef void		V;	// void


typedef CH *		PCH;
typedef CH *		SA;	// memory allocated string
typedef CH *		SZ;
typedef CU *		PCU;
typedef CU *		SZU;
typedef I *		PI;
typedef I *		PIZ;
typedef SCH *		SSZ;
typedef SC *		PSCZ;
typedef U *		PU;
typedef V *		PV;
typedef W *		PW;
typedef W *		PWZ;


typedef SZ *		PSZ;
typedef SZU *		PSZU;
typedef SSZ *		PSSZ;

typedef W		WSortPPvPv( const void *, const void * );

#define rSucced		0      // sikeres
#define rEof		EOF
#define rFail		(-2) // sikertelen

#define rClose		(-3)
#define rMkdir		(-4)
#define rNotDir		(-5)
#define rNotFound	(-6)
#define rNotMemo	(-7)
#define rNull		(-8)
#define rOpen		(-9)
#define rRead		(-10)
#define rRecursive	(-11)
#define rSeek		(-12)
#define rType		(-13)
#define rWrite		(-14)

extern SZ		szEmpty;	// ""

//---------------------------------------------------------------------

SA			SaMallocSz( SZ );	// strcpy(malloc())

R			main( C, PSZ, PSZ );

//---------------------------------------------------------------------

#define ifree( p_ )	{if((p_)!=NULL) {free(p_);(p_)=NULL;}}
#define retnull( p_ )	{if((p_)==NULL) {r=rNull;goto ret;}}

#endif

